/*======================================头像自动分割（抠头像）接口---人体头部抠图带白边======================================*/
package main

import (
	"bytes"
	"crypto/md5"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"log"
	"net/http"
)

func ImgtoBase64HeadBorder(filePath string) string {
	//图片转Base64
	bytes, err := ioutil.ReadFile(filePath)
	if err != nil {
		log.Fatal(err)
	}
	var base64Encoding string
	base64Encoding += base64.StdEncoding.EncodeToString(bytes)
	return base64Encoding
}

func MD5HeadBorder(v string) string {
	d := []byte(v)
	m := md5.New()
	m.Write(d)
	b := m.Sum(nil)
	return base64.StdEncoding.EncodeToString([]byte(b))
}

func main() {
	appCode := "你的appcodes"
	HeadBorderUrl := "https://person.market.alicloudapi.com/segment/person/head"

	client := &http.Client{}
	data := make(map[string]interface{})
	data["photo"] = ImgtoBase64HeadBorder("1.jpg")
	data["type"] = "jpg"
	data["is_crop_content"] = 0 // 可选参数，返回的图片中，是否只保留有头像内容的区域，裁剪掉其余无内容的透明区域，1为裁剪，0为不裁剪，默认为0

	bytesData, _ := json.Marshal(data)
	req, _ := http.NewRequest("POST", HeadBorderUrl, bytes.NewReader(bytesData))
	req.Header.Set("Content-Type", "application/json")
	req.Header.Set("Authorization", "APPCODE "+appCode)

	md5Str := MD5HeadBorder(string(bytesData))
	req.Header.Set("Content-MD5", md5Str)

	resp, _ := client.Do(req)
	fmt.Println(resp.Header)
	fmt.Println(resp.Header["X-Ca-Error-Message"])
	body, _ := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))

}
